package main

import "fmt"
import "bufio"
import "os"
import "encoding/json"

type Node struct {
	Content string
	Si, No *Node
}

func gioca(root *Node) {
	var curs, parent *Node
	var ultimaRispostaSi bool

	parent = nil
	curs = root
	scanner := bufio.NewScanner(os.Stdin)
	for curs.Si != nil {   // Finché è una domanda
		fmt.Printf("%s? [n=no, s=si] ", curs.Content)
		scanner.Scan()
		risp := scanner.Text()
		parent = curs
		if risp[0] == 's' {
			curs = curs.Si
			ultimaRispostaSi = true
		} else {
			curs = curs.No
			ultimaRispostaSi = false
		}
	}
	fmt.Printf("Secondo me si tratta di %s\n", curs.Content)
	fmt.Printf("Ho indovinato? [n=no, s=si] ")
	scanner.Scan()
	risp := scanner.Text()
	if risp[0] == 's' {
		fmt.Println("CAMPIONE DEL MONDO!!!\n")
	} else {
		fmt.Printf("A chi pensavi, invece: ")
		scanner.Scan()
		nomePersonaPensata := scanner.Text()
		fmt.Printf("Dimmi una domanda che distingua %s da %s (senza punto interrogativo): ", nomePersonaPensata, curs.Content)
		scanner.Scan()
		domanda := scanner.Text()
		fmt.Printf("%s %s? [n=no, s=si] ", domanda, curs.Content)
		scanner.Scan()
		rispostaDomanda := scanner.Text()

		nodoDomanda := new(Node)
		nodoDomanda.Content = domanda
		nodoRisposta := new(Node)
		nodoRisposta.Content = nomePersonaPensata

		if rispostaDomanda[0] == 's' {
			nodoDomanda.Si = curs
			nodoDomanda.No = nodoRisposta
		} else {
			nodoDomanda.Si = nodoRisposta
			nodoDomanda.No = curs

		}

		if ultimaRispostaSi {
			parent.Si = nodoDomanda
		} else {
			parent.No = nodoDomanda
		}	

		fmt.Println("Ok, la prossima volta indovinerò\n")

	}
}

func main() {
	var radice *Node

	b, err := os.ReadFile("akinator.json")

	if err != nil {  // File non esiste
    	var figliosi, figliono *Node
		radice = new(Node)
		figliosi = new(Node)
		figliono = new(Node)

		radice.Content = "E' un tennista"
		figliosi.Content = "Jannik Sinner"
		figliono.Content = "Taylor Swift"

		radice.Si = figliosi
		radice.No = figliono
	} else {
		err := json.Unmarshal(b, &radice)
		if err != nil {
			fmt.Println("Errore smaresciallando", err)
		}
	}

	for {
		gioca(radice)
		b, err := json.Marshal(radice)
		if err != nil {
			fmt.Println("Errore mentre maresciallavo:", err)
		}
		os.WriteFile("akinator.json", b, 0666)
	}
}

